image: docker:latest

variables:
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""
  GITLAB_CI: 1
  TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
  TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA

services:
  - docker:dind

before_script:
  - apk update
  - apk upgrade
  - apk add --no-cache make bash docker-compose && rm -rf /var/cache/apk/*

stages:
  - build
  - deploy

.general_scripts: &general_scripts
  - make info

build:
  stage: build
  script:
    - make build-test
    - make start-test
    - docker ps -a
    # - make wait-for-db #: error db:wait not support in laravel
    # - make drop-migrate
    # - make seed
    # - *general_scripts
    # - make phpunit
    # - make ecs
    # - make phpcs
    # - make phpstan
    # - make phpinsights
    # - make phpmd
    # - make phpcpd
    - make stop-test
  artifacts:
    paths:
      - reports/
  only:
    - merge_requests
    - tags
    - master
    - develop

# push_staging_images:
#   stage: deploy
#   script:
#     - make build-staging
#     # TODO: set necessary image name in docker-compose-staging.yml according to your registry and edit lines bellow
#     #- docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
#     #- docker-compose -f docker-compose-staging.yml push
#   only:
#     - main
#     - develop
#     - /^release.*$/

push_prod_images:
  stage: deploy
  script:
    - make build-prod
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - echo "$PATH"
    - docker images
    - docker-compose -f docker-compose-prod.yml push
  only:
    - main
    - /^release.*$/






# stages:
#   - build
#   - pro_deployment

# variables:
#     TAG_LATEST: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:latest
#     TAG_COMMIT: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHORT_SHA
#     EVN_CONTENT: $prodenv
#     DOCKER_DRIVER: overlay2
#     DOCKER_TLS_CERTDIR: "/certs"
# before_script:
#   - echo "$EVN_CONTENT" >> .env

# buid:
#   image: docker:latest
#   stage: build
#   services: 
#     - docker:19.03.0-dind
#   script:
#     # - docker build --no-cache -t $TAG_COMMIT -t $TAG_LATEST /.devops/php/Dockerfile
#     - docker build -t $TAG_COMMIT -f .devops/php/Dockerfile .
#     - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
#     - docker push $TAG_COMMIT
#     - docker push $TAG_LATEST

# pro_deployment:
#   image: alpine:latest
#   stage: pro_deployment
#   tags:
#     - pro_deployment
#   script:
#     - chmod og= $ID_RSA
#     - apk update && apk add openssh-client
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin"
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker pull $TAG_COMMIT"
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker container rm -f my-app || true"
#     - ssh -i $ID_RSA -o StrictHostKeyChecking=no $SERVER_USER@$SERVER_IP "docker run -d -p 80:80 --name my-app $TAG_COMMIT"
#   environment:
#     name: production
#     url: http://$SERVER_IP
#   only:
#     - master